
import * as cc from 'cc';
import { _decorator, Component, Node } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = Set
 * DateTime = Wed Nov 10 2021 14:08:10 GMT+0800 (中国标准时间)
 * Author = warde.huang
 * FileBasename = Set.ts
 * FileBasenameNoExtension = Set
 * URL = db://assets/Set.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/zh/
 *
 */

@ccclass('Set')
export class Set extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    start() {
        cc.resources.load("material", cc.Material, null, (error, asset) => {
            this.node.getComponent(cc.sp.Skeleton).customMaterial = asset;

            console.log("set to 0.1");
            this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 0.1);
        });

        this.scheduleOnce(() => {
            console.log("set to 0.5 not working");
            this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 0.5);

            // console.log("set to 0.5 working");
            // let mat = new cc.Material();
            // mat.copy(this.node.getComponent(cc.sp.Skeleton).customMaterial);
            // this.node.getComponent(cc.sp.Skeleton).customMaterial=mat;
            // this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 0.5);

        }, 1);

        this.scheduleOnce(() => {
            console.log("set to 1 not working");
            this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 1);


            // console.log("set to 1 working");
            // let mat = new cc.Material();
            // mat.copy(this.node.getComponent(cc.sp.Skeleton).customMaterial);
            // this.node.getComponent(cc.sp.Skeleton).customMaterial=mat;
            // this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 1);
        }, 2);

        this.scheduleOnce(() => {
            console.log("set to 0 not working");
            this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 0);

            // console.log("set to 0 working");
            // let mat = new cc.Material();
            // mat.copy(this.node.getComponent(cc.sp.Skeleton).customMaterial);
            // this.node.getComponent(cc.sp.Skeleton).customMaterial=mat;
            // this.node.getComponent(cc.sp.Skeleton).customMaterial.setProperty("tintPower", 0);
        }, 3);
    }


    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.3/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.3/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.3/manual/zh/scripting/life-cycle-callbacks.html
 */
